<template>
  <form @submit.prevent="submitForm" method="post">
    <el-dialog
      title="เพิ่มผู้รับผิดชอบ"
      v-model="openDialog"
      width="350px"
      :before-close="handleClose"
    >
      <div class="mb-2 grid">
        <p>คำนำหน้า</p>
        <input
          :class="`${errors.title ? ' border-red-600' : ''}
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300`"
          v-model="form.title"
          placeholder="คำนำหน้า"
        />
        <small class="text-red-500 font-bold">{{ errors?.title }} </small>
      </div>
      <div class="mb-2 grid">
        <p>ชื่อ</p>
        <input
          :class="`${errors.firstname ? ' border-red-600' : ''}
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300`"
          v-model="form.firstname"
          placeholder="ชื่อ"
        />
        <small class="text-red-500 font-bold">{{ errors?.firstname }} </small>
      </div>
      <div class="mb-2 grid">
        <p>นามสกุล</p>
        <input
          :class="`${errors.lastname ? ' border-red-600' : ''}
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300`"
          v-model="form.lastname"
          placeholder="นามสกุล"
        />
        <small class="text-red-500 font-bold">{{ errors?.lastname }} </small>
      </div>
      <template #footer>
        <span class="dialog-footer">
          <button
            @click="handleClose"
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-red-600
              to-red-400
              rounded-md
              text-white
              shadow-md
              mr-2
              focus:outline-none
            "
            type="button"
          >
            ยกเลิก
          </button>
          <button
            type="submit"
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-blue-600
              to-green-400
              rounded-md
              text-white
              shadow-md
              focus:outline-none
            "
          >
            เพิ่ม
          </button>
        </span>
      </template>
    </el-dialog>
  </form>
</template>

<script>
import { Inertia } from "@inertiajs/inertia";
import { defineComponent, reactive, ref, toRefs, watch } from "vue";

export default defineComponent({
  props: {
    open: {
      type: Boolean,
      required: true,
    },
  },
  setup(props, { emit }) {
    //   model
    const { open } = toRefs(props);
    const openDialog = ref(false);
    watch(open, (value, prevValue) => {
      openDialog.value = value;
      console.log(value);
    });
    // form

    const form = reactive({
      title: null,
      firstname: null,
      lastname: null,
    });
    const errors = reactive({
      title: null,
      firstname: null,
      lastname: null,
    });
    const submitForm = () => {
      Inertia.post(route("admin.owners.store"), form, {
        onError: (err) => {
          errors.title = err.title;
          errors.firstname = err.firstname;
          errors.lastname = err.lastname;
        },
        onSuccess: () => handleClose(),
      });
    };

    const handleClose = () => {
      emit("close");
      openDialog.value = false;
      errors.title = null;
      errors.firstname = null;
      errors.lastname = null;
      form.title = null;
      form.firstname = null;
      form.lastname = null;
    };
    return {
      openDialog,
      handleClose,
      submitForm,
      form,
      errors,
    };
  },
});
</script>
